//---------------------------------------------------------------------------
#pragma inline
#include <vcl.h>
#pragma hdrstop

#include <math.h>
#include "SMP_ATask.h"
#include "SMP_Test.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
void __fastcall TSMP_AThread::Execute(void)
{
	int i;
	int NBUF,NY;
	const int NX=1024;
	volatile unsigned char *buf;
	volatile register double r1;
	int *Histogram;
	const int OType=SMPTest->Operation->ItemIndex;

	switch (SMPTest->MemorySize->ItemIndex) {
		case 0: NY=128; break;
		case 1: NY=256; break;
		case 2: NY=512; break;
		case 3: NY=1024; break;
		case 4: NY=2048; break;
		case 5: NY=4096; break;
		default: NY=128;
	}

	NBUF=NY*NX;
	buf=new unsigned char [NBUF];
	for (i=0;i<NBUF;i++) buf[i]=(unsigned char)i;
	Histogram=new int [256];
	t0=GetTickCount();

	while (!Terminated) {
		switch (OType) {
			case 0:
				for (i=0;i<NY;i++)
				r1=sin(0.025*i);
				break;
			case 1:
				asm {
					mov edx,NBUF
					mov ebx,buf
					step1:
					mov al,byte ptr [ebx]
					inc ebx
					dec edx
					jnz step1
				}
				break;
			case 2:
				asm {
					mov al,0
					mov edx,NBUF
					mov ebx,buf
					step2:
					mov byte ptr [ebx],al
					inc ebx
					dec edx
					jnz step2
				}
				break;
			case 3:
				asm {
					mov edx,NBUF
					mov ebx,buf
					step3:
					inc byte ptr [ebx]
					inc ebx
					dec edx
					jnz step3
				}
				break;
			case 4:
				asm {
					mov edx,256
					mov ebx,Histogram
					step4a:
					mov dword ptr [ebx],0
          add ebx,4
					dec edx
					jnz step4a

					mov edx,NBUF
					mov ebx,buf
					mov ecx,Histogram
					step4:
          xor eax,eax
					mov al,byte ptr [ebx]
          shl eax,2
					inc dword ptr [ecx+eax]
					inc ebx
					dec edx
					jnz step4
				}
				break;
			case 5:
				asm {
					mov edx,NBUF
					mov ebx,buf
					mov cl,128
					step5:
					cmp byte ptr [ebx],cl
					jg step5a
					mov byte ptr [ebx],0
					jmp step5b
					step5a:
					mov byte ptr [ebx],255
					step5b:
					inc ebx
					dec edx
					jnz step5
				}
				break;
		}
		NR++;
		t1=GetTickCount();
		dt=t1-t0;
		if (dt<0) {
			dt=0;
			t0=t1;
			NR=0;
		}
		if (dt>=1000) {
			t0=t1;
			NumRun=NR;
			NR=0;
			if (SMPTest->Operation->ItemIndex!=0) BytesPerSecond=NumRun*NBUF;
		}
	}

	delete[] Histogram;
	delete[] buf;
}
//---------------------------------------------------------------------------
__fastcall TSMP_AThread::TSMP_AThread(void)
	:TThread(true)
{
	FreeOnTerminate=false;
}
