//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SMP_Test.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "SMP_ATask.h"
#include "SMP_CTask.h"
//---------------------------------------------------------------------
#pragma link "cgauges"
#pragma resource "*.dfm"
TSMPTest *SMPTest;
//---------------------------------------------------------------------
__fastcall TSMPTest::TSMPTest(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void __fastcall TSMPTest::TrackBar1Change(TObject *Sender)
{
  AdjustTasks(TrackBar1->Position);
}
//---------------------------------------------------------------------------
void __fastcall TSMPTest::FormShow(TObject *Sender)
{
	SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);
	TrackBar1->Enabled=false;
  TrackBar1->Max=NSMPTASKS;
  TrackBar1->Position=1;
	TrackBar1->Enabled=true;
	AdjustTasks(TrackBar1->Position);
}
//---------------------------------------------------------------------------
void TSMPTest::AdjustTasks(int NTasks)
{
	int i;
	double dt,LastTR,pc;

	if (NTasks!=RTasks && TrackBar1->Enabled) {
		TrackBar1->Enabled=false;
		CloseButton->Enabled=false;
		CodeType->Enabled=false;
		Operation->Enabled=false;
		MemorySize->Enabled=false;
		Timer1->Enabled=false;
		for (i=0;i<RTasks;i++)
		if (Tasks[i]!=NULL) {
			Tasks[i]->Terminate();
			Tasks[i]->WaitFor();
			delete Tasks[i];
			Tasks[i]=NULL;
		}
		RTasks=NTasks;
		if (RTasks>0) {
			if (CodeType->ItemIndex==0)
			Tasks[0]=new TSMP_AThread();
			else
			Tasks[0]=new TSMP_CThread();
			Tasks[0]->Priority=tpLower;
			Tasks[0]->Resume();
			Timer1->Enabled=true;
			LastTR=0.0;
			i=0;
			do {
				TotalRun=0;
				while (TotalRun==0) {
					Application->ProcessMessages();
				}
				dt=fabs(TotalRun-LastTR);
				LastTR=TotalRun;
				if ((i>=4) && (TotalRun>0.0))
				pc=dt/TotalRun;
				else
				pc=1.0;
				i++;
			} while ((i<=10) && (pc>0.01));
			TotalOne=TotalRun;
			ProgressBar1->Max=TotalOne*NSMPTASKS;
			for (i=1;i<RTasks;i++) {
				if (CodeType->ItemIndex==0)
				Tasks[i]=new TSMP_AThread();
				else
				Tasks[i]=new TSMP_CThread();
				Tasks[i]->Priority=tpLower;
				Tasks[i]->Resume();
			}
		}
		GroupBox2->Caption="Run "+IntToStr(RTasks)+" Task(s)";
		Operation->Enabled=true;
		MemorySize->Enabled=true;
		CodeType->Enabled=true;
		TrackBar1->Enabled=true;
		CloseButton->Enabled=true;
	}
}
//---------------------------------------------------------------------------
void __fastcall TSMPTest::Timer1Timer(TObject *Sender)
{
	int i,t;
	double bps,PCent;

	t=0;
	bps=0;
	for (i=0;i<RTasks;i++)
	if (Tasks[i]!=NULL) {
		if (CodeType->ItemIndex==0) {
			t+=((TSMP_AThread*)Tasks[i])->NumRun;
			bps+=((TSMP_AThread*)Tasks[i])->BytesPerSecond;
		} else {
			t+=((TSMP_CThread*)Tasks[i])->NumRun;
			bps+=((TSMP_CThread*)Tasks[i])->BytesPerSecond;
		}
	}
	TotalRun=t;
	TotalBytesPerSecond=bps;

	ProgressBar1->Position=t;
	if (TotalOne>0) PCent=100.0*TotalRun/TotalOne;
	else PCent=0.0;
	if (TrackBar1->Enabled) {
		Edit1->Text=IntToStr(t)+" = "+FloatToStrF(PCent,ffFixed,3,0)+"%";
		Edit2->Text=FloatToStrF(TotalBytesPerSecond,ffNumber,12,0)
			+" = "+FloatToStrF(TotalBytesPerSecond/1024/1024,ffNumber,12,1)+" MB/S";
	} else {
		Edit1->Text="Please wait...";
		Edit2->Text="Please wait...";
	}
}
//---------------------------------------------------------------------------
void __fastcall TSMPTest::FormClose(TObject *Sender, TCloseAction &Action)
{
	AdjustTasks(0);
  Timer1->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TSMPTest::OperationClick(TObject *Sender)
{
  AdjustTasks(0);
  AdjustTasks(TrackBar1->Position);
}
//---------------------------------------------------------------------------

